Bug 1685022 - Review Request: HepMC3 - C++ Event Record for Monte Carlo Generators
Summary: Review Request: HepMC3 - C++ Event Record for Monte Carlo Generators
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-04 07:37 UTC by Mattias Ellert
Modified: 2019-03-29 19:10 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-03-15 03:35:20 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Mattias Ellert 2019-03-04 07:37:23 UTC
Spec URL: http://www.grid.tsl.uu.se/review/HepMC3.spec
SRPM URL: http://www.grid.tsl.uu.se/review/HepMC3-3.1.0-1.fc29.src.rpm

Description:
The HepMC3 package is an object oriented, C++ event record for
High Energy Physics Monte Carlo generators and simulation.
Since the first implementation, described in M. Dobbs and J.B. Hansen
(Comput. Phys. Commun. 134 (2001) 41), the package has undergone
several modifications and in particular, the latest HepMC3 series is a
completely new re-write using currently available C++11 techniques.

Fedora Account System Username: ellert

This is a new version of the HepMC library already available in Fedora.
However, it is not an update that is a drop in replacement for the old version.
The new version is written to be parallel installable with the old version without conflicts in library names and install paths, so that both versions can bi installed at the same time.

Comment 1 Robert-André Mauchin 🐧 2019-03-04 17:06:11 UTC
 - make %{?_smp_mflags} → %make_build

 - make install DESTDIR=%{buildroot} → %make_install

 - The libraries should be versioned:

%{_libdir}/libHepMC3.so

%{_libdir}/libHepMC3search.so


See https://docs.fedoraproject.org/en-US/packaging-guidelines/#_downstream_so_name_versioning

In cases where upstream ships unversioned .so library (so this is not needed for plugins, drivers, etc.), the packager MUST try to convince upstream to start versioning it.

If that fails due to unwilling or unresposive upstream, the packager may start versioning downstream but this must be done with caution and ideally only in rare cases. We don’t want to create a library that could conflict with upstream if they later start providing versioned shared libraries. Under no circumstances should the unversioned library be shipped in Fedora.

For downstream versioning, the name should be composed like this:

libfoobar.so.0.n

The n should initially be a small integer (for instance, "1"). we use two digits here ("0.n") because the common practice with upstreams is to use only a single digit here. Using multiple digits helps us avoid potential future conflicts. Do not forget to add the SONAME field (see below) to the library.

When new versions of the library are released, you should use an ABI comparison tool to check for ABI differences in the built shared libraries. If it detects any incompatibilities, bump the n number by one.

→ Ask upstream to adopt SONAME versioning.

Comment 2 Mattias Ellert 2019-03-05 10:11:49 UTC
(In reply to Robert-André Mauchin from comment #1)
>  - make %{?_smp_mflags} → %make_build
> 
>  - make install DESTDIR=%{buildroot} → %make_install

I know these macros exist. I find them to be obfuscating and confusing and not at all helpful or clarifying. So not using them was a conscious decision on my part. For me they make the specfile harder to read.

>  - The libraries should be versioned:
> 
> %{_libdir}/libHepMC3.so
> 
> %{_libdir}/libHepMC3search.so

I contacted uppstream and they added a soname, I have added a patch with this change taken from the upstream git in this updated version:

Spec URL: http://www.grid.tsl.uu.se/review/HepMC3.spec
SRPM URL: http://www.grid.tsl.uu.se/review/HepMC3-3.1.0-2.fc29.src.rpm

Comment 3 Robert-André Mauchin 🐧 2019-03-05 14:37:43 UTC
 - Note: %ldconfig_scriptlets is not needed anymore on F30/Rawhide. If you plan for F29/EPEL, it's ok to keep it.

 - There are issues with the interface subpackage. It contains include files and require a -devel dependency:

HepMC3-interfaces.noarch: E: devel-dependency HepMC3-devel


HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Photospp/include/Photos/PhotosHepMC3Event.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Photospp/include/Photos/PhotosHepMC3Particle.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Tauolapp/include/Tauola/TauolaHepMC3Event.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Tauolapp/include/Tauola/TauolaHepMC3Particle.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Tauolapp/src/TauolaHepMC3Event.cxx
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Tauolapp/src/TauolaHepMC3Particle.cxx
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/mc-tester/include/HepMC3Event.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/mc-tester/include/HepMC3Particle.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/mc-tester/src/HepMC3Event.cxx
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/mc-tester/src/HepMC3Particle.cxx
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/pythia8/include/Pythia8/Pythia8ToHepMC3.h

   Should this be a interfaces-devel package instead?





Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Header files in -devel subpackage, if present.
  Note: HepMC3-interfaces :
  /usr/share/HepMC3/interfaces/Photospp/include/Photos/PhotosHepMC3Event.h
  HepMC3-interfaces :
  /usr/share/HepMC3/interfaces/Photospp/include/Photos/PhotosHepMC3Particle.h
  HepMC3-interfaces :
  /usr/share/HepMC3/interfaces/Tauolapp/include/Tauola/TauolaHepMC3Event.h
  HepMC3-interfaces :
  /usr/share/HepMC3/interfaces/Tauolapp/include/Tauola/TauolaHepMC3Particle.h
  HepMC3-interfaces : /usr/share/HepMC3/interfaces/mc-
  tester/include/HepMC3Event.h HepMC3-interfaces :
  /usr/share/HepMC3/interfaces/mc-tester/include/HepMC3Particle.h
  HepMC3-interfaces :
  /usr/share/HepMC3/interfaces/pythia8/include/Pythia8/Pythia8ToHepMC3.h
  HepMC3-doc : /usr/share/doc/HepMC3/examples/ConvertExample/cmdline.h
  HepMC3-doc :
  /usr/share/doc/HepMC3/examples/ConvertExample/include/WriterHEPEVTZEUS.h
  HepMC3-doc :
  /usr/share/doc/HepMC3/examples/ConvertExample/include/WriterRootTreeOPAL.h
  HepMC3-doc :
  /usr/share/doc/HepMC3/examples/RootIOExample2/include/LinkDef.h
  HepMC3-doc :
  /usr/share/doc/HepMC3/examples/RootIOExample2/include/MyClass.h
  HepMC3-doc :
  /usr/share/doc/HepMC3/examples/RootIOExample2/include/MyRunClass.h
  HepMC3-doc :
  /usr/share/doc/HepMC3/examples/RootIOExample2/include/myclass_Classes.h
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GNU General Public License", "GPL (v2)", "Unknown or
     generated". 227 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/HepMC3/review-
     HepMC3/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in HepMC3
     -search-devel , HepMC3-rootIO-devel , HepMC3-interfaces , HepMC3-doc ,
     HepMC3-debuginfo , HepMC3-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: HepMC3-3.1.0-2.fc31.x86_64.rpm
          HepMC3-devel-3.1.0-2.fc31.x86_64.rpm
          HepMC3-search-3.1.0-2.fc31.x86_64.rpm
          HepMC3-search-devel-3.1.0-2.fc31.x86_64.rpm
          HepMC3-rootIO-3.1.0-2.fc31.x86_64.rpm
          HepMC3-rootIO-devel-3.1.0-2.fc31.x86_64.rpm
          HepMC3-interfaces-3.1.0-2.fc31.noarch.rpm
          HepMC3-doc-3.1.0-2.fc31.noarch.rpm
          HepMC3-debuginfo-3.1.0-2.fc31.x86_64.rpm
          HepMC3-debugsource-3.1.0-2.fc31.x86_64.rpm
          HepMC3-3.1.0-2.fc31.src.rpm
HepMC3.x86_64: W: spelling-error %description -l en_US Dobbs -> Hobbs, Dobs, Dobbins
HepMC3.x86_64: W: spelling-error %description -l en_US Commun -> Com mun, Com-mun, Commune
HepMC3.x86_64: W: no-documentation
HepMC3-devel.x86_64: W: no-documentation
HepMC3-devel.x86_64: W: no-manual-page-for-binary HepMC3-config
HepMC3-search.x86_64: W: no-documentation
HepMC3-search-devel.x86_64: W: no-documentation
HepMC3-rootIO.x86_64: W: no-documentation
HepMC3-rootIO.x86_64: W: devel-file-in-non-devel-package /usr/lib64/root/libHepMC3rootIO.so
HepMC3-rootIO-devel.x86_64: W: no-documentation
HepMC3-interfaces.noarch: E: devel-dependency HepMC3-devel
HepMC3-interfaces.noarch: W: no-documentation
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Photospp/include/Photos/PhotosHepMC3Event.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Photospp/include/Photos/PhotosHepMC3Particle.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Tauolapp/include/Tauola/TauolaHepMC3Event.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Tauolapp/include/Tauola/TauolaHepMC3Particle.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Tauolapp/src/TauolaHepMC3Event.cxx
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/Tauolapp/src/TauolaHepMC3Particle.cxx
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/mc-tester/include/HepMC3Event.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/mc-tester/include/HepMC3Particle.h
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/mc-tester/src/HepMC3Event.cxx
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/mc-tester/src/HepMC3Particle.cxx
HepMC3-interfaces.noarch: W: devel-file-in-non-devel-package /usr/share/HepMC3/interfaces/pythia8/include/Pythia8/Pythia8ToHepMC3.h
HepMC3.src: W: spelling-error %description -l en_US Dobbs -> Hobbs, Dobs, Dobbins
HepMC3.src: W: spelling-error %description -l en_US Commun -> Com mun, Com-mun, Commune
11 packages and 0 specfiles checked; 1 errors, 24 warnings.

Comment 4 Mattias Ellert 2019-03-05 16:19:40 UTC
(In reply to Robert-André Mauchin from comment #3)
>  - Note: %ldconfig_scriptlets is not needed anymore on F30/Rawhide. If you
> plan for F29/EPEL, it's ok to keep it.

This is for EPEL 7 too.

>  - There are issues with the interface subpackage. It contains include files
> and require a -devel dependency:
> 
> HepMC3-interfaces.noarch: E: devel-dependency HepMC3-devel
> 
> [...]
> 
>    Should this be a interfaces-devel package instead?

This is reasonable. New version:

Spec URL: http://www.grid.tsl.uu.se/review/HepMC3.spec
SRPM URL: http://www.grid.tsl.uu.se/review/HepMC3-3.1.0-3.fc29.src.rpm

Comment 5 Robert-André Mauchin 🐧 2019-03-05 17:31:03 UTC
All good, package approved.

Comment 6 Gwyn Ciesla 2019-03-05 20:32:20 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/HepMC3

Comment 7 Fedora Update System 2019-03-06 06:45:51 UTC
HepMC3-3.1.0-3.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-2432033d99

Comment 8 Fedora Update System 2019-03-06 06:45:54 UTC
HepMC3-3.1.0-3.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2019-0bc7b26f0f

Comment 9 Fedora Update System 2019-03-06 06:46:00 UTC
HepMC3-3.1.0-3.fc30 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-94e3dca61c

Comment 10 Fedora Update System 2019-03-06 06:46:07 UTC
HepMC3-3.1.0-3.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-99c85070a4

Comment 11 Mattias Ellert 2019-03-06 06:49:47 UTC
(In reply to Robert-André Mauchin from comment #5)
> All good, package approved.

Thank you for the review.

Comment 12 Fedora Update System 2019-03-06 15:13:10 UTC
HepMC3-3.1.0-3.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-0bc7b26f0f

Comment 13 Fedora Update System 2019-03-06 15:57:22 UTC
HepMC3-3.1.0-3.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-99c85070a4

Comment 14 Fedora Update System 2019-03-06 16:14:38 UTC
HepMC3-3.1.0-3.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-2432033d99

Comment 15 Fedora Update System 2019-03-06 22:53:56 UTC
HepMC3-3.1.0-3.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-94e3dca61c

Comment 16 Fedora Update System 2019-03-15 03:35:20 UTC
HepMC3-3.1.0-3.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2019-03-15 18:29:09 UTC
HepMC3-3.1.0-3.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2019-03-21 22:49:51 UTC
HepMC3-3.1.0-3.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2019-03-29 19:10:20 UTC
HepMC3-3.1.0-3.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.